﻿using System;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;


public partial class _Default : System.Web.UI.Page 
{
    private void BindGridView(string criteria)
    {
        string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
        NorthwindDb db = new NorthwindDb(strConn);

        IEnumerable<Employee> results;

        if (criteria == string.Empty)
        {
            results=db.Employee.ToArray();
        }
        else
        {
            results = (from c in db.Employee
                          where c.FirstName.Contains(criteria)
                          select c).ToArray();
            
        }
        GridView1.DataSource = results;
        GridView1.DataBind();
    }

    private void BindDetailsView()
    {
        int employeeID = (int)GridView1.SelectedValue;
        string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
        NorthwindDb db = new NorthwindDb(strConn);

        var results = from emp in db.Employee
                      where emp.EmployeeID == employeeID
                      select emp;

        DetailsView1.DataSource = results;
        DetailsView1.DataBind();

    }


    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            BindGridView(string.Empty);
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        BindGridView(TextBox1.Text);
    }
    protected void GridView1_SelectedIndexChanging(object sender, GridViewSelectEventArgs e)
    {
        GridView1.SelectedIndex = e.NewSelectedIndex;
    }
    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
        int employeeID = (int)GridView1.SelectedValue;
        string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
        BindDetailsView();
    }
    protected void DetailsView1_ItemUpdating(object sender, DetailsViewUpdateEventArgs e)
    {
        string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
        NorthwindDb db = new NorthwindDb(strConn);

        var results = from emp in db.Employee
                                        where emp.EmployeeID == (int)DetailsView1.SelectedValue
                                        select emp;


        results.First().FirstName = ((TextBox)DetailsView1.Rows[1].Cells[1].Controls[0]).Text;
        results.First().LastName = ((TextBox)DetailsView1.Rows[2].Cells[1].Controls[0]).Text;
        
        db.SubmitChanges();
        BindGridView(string.Empty);

    }
    protected void DetailsView1_ItemInserting(object sender, DetailsViewInsertEventArgs e)
    {
        string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
        NorthwindDb db = new NorthwindDb(strConn);

        Employee emp = new Employee();
        emp.FirstName = ((TextBox)DetailsView1.Rows[1].Cells[1].Controls[0]).Text;
        emp.LastName= ((TextBox)DetailsView1.Rows[2].Cells[1].Controls[0]).Text;
        db.Employee.InsertOnSubmit(emp);
        db.SubmitChanges();
        BindGridView(string.Empty);

    }
    protected void DetailsView1_ModeChanging(object sender, DetailsViewModeEventArgs e)
    {
        DetailsView1.ChangeMode(e.NewMode);
        BindDetailsView();
    }
    protected void DetailsView1_ModeChanged(object sender, EventArgs e)
    {
        
    }
    protected void DetailsView1_ItemDeleting(object sender, DetailsViewDeleteEventArgs e)
    {
        string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
        NorthwindDb db = new NorthwindDb(strConn);

        var results = db.Employee.Single(emp => emp.EmployeeID==(int)DetailsView1.SelectedValue);
        db.Employee.DeleteOnSubmit(results);
        db.SubmitChanges();
        BindGridView(string.Empty);

    }
}
